/**************************************************************** 
 * Description: 洛谷：P3252
 * Author: Alex Li
 * Date: 2024-01-25 18:30:43
 * LastEditTime: 2024-01-25 21:24:45
****************************************************************/
#include <iostream>
#include <cstdio>
#include <cstring>
#include <algorithm>
using namespace std; 

const int N=100005;  //最大节点数
struct edge{
    int from,to,val,next;
}r[N];


int t,x,y; //中间变量
long long ans,sum;
int head[N]; //存储每个节点的第一条边的索引。

void add(int a,int b){
    t++;
    r[t].from=a;
    r[t].to=b;
    r[t].next=head[a]; //head[a]做为a结点的索引，建立邻接表
    head[a]=t;

}

void dfs(int u, int s){
    /*这个 for 循环通过遍历节点 u 的邻接链表，访问了 u 的所有相邻节点。在每次迭代中，
    i 指向当前考虑的边，通过 r[i].to 可以访问与 u 相连的下一个节点。*/
    for (int i =head[u];i;i=r[i].next ){ 
        sum+=r[r[i].to].val;
        if(sum>s){
            sum-=r[r[i].to].val;
            continue;
        }
        else if(sum==s){ //如果当前路径和等于目标值s，则答案加一
            ans++;
            sum-=r[r[i].to].val;  //撤回到上一步接着搜
            continue;

        }
        dfs(r[i].to,s);
        sum-=r[r[i].to].val;
    }
    
}

int main(){
    int n,s;
    cin>>n>>s;  //读进来n和s，n是结点数，s是权值
    
    for(int i=1;i<=n;i++)cin>>r[i].val; //把每个结果权值读进来
    
    //读入边的信息
    for(int i=1;i<n;i++){ //边比结点少一个， 所以是n-1
        cin>>x>>y;
        add(x,y);
    }

    for(int i=1;i<=n;i++){
        if(r[i].val>s)continue;
        if(r[i].val==s)ans++;
        else {
            sum=r[i].val;
            dfs(i,s);
        }
    }
   cout<<ans;
}